// Select your modem:
#define TINY_GSM_MODEM_SIM800

#include <TinyGsmClient.h>
#include <PubSubClient.h>

// or Software Serial on Uno, Nano
#include <HardwareSerial.h>
HardwareSerial SerialAT(1); // TX, RX

// Your GPRS credentials
// Leave empty, if missing user or pass
const char apn[]  = "datatem.algar.br";//"zap.vivo.com.br"; //"claro.com.br";//timbrasil.br;
const char user[] = "datatem";//"vivo"; //"claro";//"tim";
const char pass[] = "datatem";//"vivo"; //"claro";//"tim";

// MQTT details
const char* broker = "industrial.api.ubidots.com";
const char* token = "BBUS-cgZYNfr2K64ZsOBBiv8sUaTwbFRXqb"; 
const char * VARIABLE_LABEL_1 = "temperature"; // Assing the variable label
const char * DEVICE_LABEL = "opm001_gprs";//"OPM001"; // Assig the device label

unsigned long TMR_POST;
float temperature = 20;

/* Space to store the request */
char payload[300];
char topic[150];

/* Space to store values to send */
char str_temperature[10];
//char str_battvoltage[10];
//char str_signalq[10];

TinyGsm modem(SerialAT);
TinyGsmClient client(modem);
PubSubClient mqtt(client);

long lastReconnectAttempt = 0;

void setup() {
  // Set console baud rate
  Serial.begin(115200);
  delay(10);



  // Set GSM module baud rate
  SerialAT.begin(9600);
  delay(3000);

  // Restart takes quite some time
  // To skip it, call init() instead of restart()
  Serial.println("Initializing modem...");
  modem.restart();

  String modemInfo = modem.getModemInfo();
  Serial.print("Modem: ");
  Serial.println(modemInfo);

  // Unlock your SIM card with a PIN
  //modem.simUnlock("1234");

  Serial.print("Waiting for network...");
  if (!modem.waitForNetwork()) {
    Serial.println(" fail");
    while (true);
  }
  Serial.println(" OK");

  Serial.print("Connecting to ");
  Serial.print(apn);
  if (!modem.gprsConnect(apn, user, pass)) {
    Serial.println(" fail");
    while (true);
  }
  Serial.println(" OK");

  // MQTT Broker setup
  mqtt.setServer(broker, 1883);
  mqtt.setCallback(mqttCallback);
}

boolean mqttConnect() {
  Serial.print("Connecting to ");
  Serial.print(broker);

  // Or, if you want to authenticate MQTT:
  boolean status = mqtt.connect("", token, token);

  if (status == false) {
    Serial.println(" fail");
    return false;
  }
  Serial.println(" OK");
  return mqtt.connected();
}

void loop() {
  if (!mqtt.connected()) {
    Serial.println("=== MQTT NOT CONNECTED ===");
    // Reconnect every 10 seconds
    unsigned long t = millis();
    if (t - lastReconnectAttempt > 10000L) {
      lastReconnectAttempt = t;
      if (mqttConnect()) {
        lastReconnectAttempt = 0;
      }
    }
    return;
  }

  /* Reading temperature and humidity */
  //float battlevel = modem.getBattPercent();
  //float battvoltage = modem.getBattVoltage() / 1000.0F;
  //float signalq = modem.getSignalQuality();

  /* 4 is mininum width, 2 is precision; float value is copied onto str_sensor*/
  dtostrf(temperature, 3, 0, str_temperature);
  //dtostrf(battvoltage, 4, 2, str_battvoltage);
  //dtostrf(signalq, 3, 0, str_signalq);
  
  /* Building the Ubidots request */
  //sprintf(topic, "%s", "channels/1393455/publish/fields/");
  sprintf(topic, "%s%s", "/v2.0/devices/", DEVICE_LABEL);
  sprintf(payload, "%s", ""); // Cleans the payload
  sprintf(payload, "{\"%s\": %s}", VARIABLE_LABEL_1, str_temperature); // Adds the variable label
  //sprintf(payload, "%s\"%s\": %s,", payload, VARIABLE_LABEL_2, str_battvoltage); // Adds the variable label
  //sprintf(payload, "%s\"%s\": %s}", payload, VARIABLE_LABEL_3, str_signalq); // Adds the variable label
  
  if (millis() > TMR_POST + 30000){
  temperature++;
    if (temperature > 30){
      temperature = 20;
    }
  Serial.println("Publishing data");
  mqtt.publish(topic, payload);
  mqtt.loop();
  TMR_POST = millis();  
  }
  
  delay(1000);
}

void mqttCallback(char* topic, byte* payload, unsigned int len) {
  Serial.print("Message arrived [");
  Serial.print(topic);
  Serial.print("]: ");
  Serial.write(payload, len);
  Serial.println();
}